package com.engine.organization.service;

import com.engine.organization.entity.sequence.param.SequenceSearchParam;
import com.engine.organization.util.MenuBtn;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/12
 * @version: 1.0
 */
public interface SequenceService {
    /**
     * 岗位列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 新增岗位
     * @param param
     * @return
     */
    int saveSequence(SequenceSearchParam param);

    /**
     * 更新岗位信息
     *
     * @param param
     * @return
     */
    int updateSequence(SequenceSearchParam param);

    /**
     * 更新禁用标记
     *
     * @param params
     */
    int updateForbiddenTagById(SequenceSearchParam params);

    /**
     * 根据ID批量删除
     *
     * @param ids
     */
    int deleteByIds(Collection<Long> ids);

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    Map<String, Object> getSearchCondition(Map<String, Object> params);


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    Map<String, Object> getSequenceForm(Map<String, Object> params);

    /**
     * 获取列表页面按钮信息
     * @return
     */
    Map<String, List<MenuBtn>> getHasRight();

    /**
     * 获取列表tabs
     * @return
     */
    Map<String, Object> getTabInfo();

    /**
     * 获取岗位序列下方案信息
     * @param params
     * @return
     */
    Map<String, Object> getSchemeInfo(Map<String, Object> params);
}
